private import opengl;

private import myio;

private import std.file;
private import std.ctype;
private import std.math;

char[5][5][10] numshape;
char[5][5][26] alphashape;

static void initLetter() {
	char[] moji = cast(char[])std.file.read("moji.txt");
	for (int i = 0; i < 10; i++) {
		for (int j = 0; j < 5; j++) {
			for (int k = 0; k < 5; k++) {
				numshape[i][j][k] = moji[(i*5+j)*6+k];
			}
		}
	}
	for (int i = 0; i < 26; i++) {
		for (int j = 0; j < 5; j++) {
			for (int k = 0; k < 5; k++) {
				alphashape[i][j][k] = moji[((i+10)*5+j)*6+k];
			}
		}
	}
}

private void drawPrim(char[5][5] dat, float bx,
					  float dx, float dy, float mx, float my) {
	for (int i = 0; i < 5; i++) {
		for (int j = 0; j < 5; j++) {
			if (dat[i][j] == ' ') continue;

			float x = bx + (j - 1) * dx * 2;
			float y = (i - 2) * dy * 2;
			glVertex3f(x-dx, y-dy, 0);
			glVertex3f(x+dx, y-dy, 0);
			glVertex3f(x+dx, y+dy, 0);
			glVertex3f(x-dx, y+dy, 0);

			glVertex3f(x-mx, y-my, 0);
			glVertex3f(x+mx, y-my, 0);
			glVertex3f(x+mx, y+my, 0);
			glVertex3f(x-mx, y+my, 0);

		}
	}
}
					  

void drawNum(int num, int x, int y, float sx, float sy,
			 float r, float g, float b) {
	glPushMatrix();

	glTranslatef(x, y, 0);

	glColor4f(r, g, b, 0.4);

	float dx = sx / 16;
	float dy = sy / 12;
	float mx = dx * 0.5;
	float my = dy * 0.5;

	int[] nums;
	if (num == 0) nums ~= 0;
	else {
		while (num != 0) {
			int next = num / 10;
			nums ~= num - next * 10;
//			if (num == 10) nums ~= 0;
			num = next;
		}
	}

	glBegin(GL_QUADS);
	for (int n = 0; n < nums.length; n++) {
		float bx = sx * (0.5 + n);
		drawPrim(numshape[nums[nums.length-n-1]],
				 bx, dx, dy, mx, my);
	}
	glEnd();

	glPopMatrix();
}

void drawString(string str, int x, int y, float sx, float sy,
				float r, float g, float b) {
	glPushMatrix();

	glTranslatef(x, y, 0);

	glColor4f(r, g, b, 0.4);

	float dx = sx / 16;
	float dy = sy / 12;
	float mx = dx * 0.5;
	float my = dy * 0.5;

	glBegin(GL_QUADS);
	for (int n = 0; n < str.length; n++) {
		float bx = sx * (0.5 + n);
		if (isalpha(str[n])) {
			drawPrim(alphashape[str[n]-'A'], bx, dx, dy, mx, my);
		}
		else if (isdigit(str[n])) {
			drawPrim(numshape[str[n]-'0'], bx, dx, dy, mx, my);
		}
	}
	glEnd();

	glPopMatrix();
}

void drawNumR(int num, int x, int y, float sx, float sy,
			  float r, float g, float b) {
	if (num != 0) {	x -= sx * cast(int)(log10(num)); }
	drawNum(num, x, y, sx, sy, r, g, b);
}
