private import std.stream;
private import std.cstream;
private import std.string;
private import std.c.stdlib;

private import SDL;

class Log {
	static void init() {
		version (Win32) {
			s = new File("out.txt", FileMode.OutNew);
		}
        else {
			s = dout;
		}
	}
	static void quit() {
		version (Win32) {
			s.close();
		}
	}
	static Stream s;

	static bit errored = false;
	static void report(string tag, invariant(char[]) msg) {
		s.writeLine("[" ~ tag ~ "] " ~ msg);
	}
	static void error(invariant(char[]) msg) {
		report("ERROR", msg);
		errored = true;
		assert(false);
	}
	static void errorSDL(invariant(char[]) msg) {
		error("[SDL] " ~ msg ~ ": " ~ std.string.toString(SDL_GetError()));
	}
	static void warn(invariant(char[]) msg) {
		report("WARN", msg);
	}
	static void warn(char[] msg) {
		warn(cast(string)msg);
	}
	static void warnSDL(invariant(char[]) msg) {
		warn("[SDL] " ~ msg ~ ": " ~ std.string.toString(SDL_GetError()));
	}
	static void info(invariant(char[]) msg) {
		report("INFO", msg);
	}
	static void info(char[] msg) {
		info(cast(string)msg);
	}
	static void dbg(invariant(char[]) msg) {
		debug {
			report("DBG", msg);
		}
	}
	static void dbg(int msg) {
		debug {
			report("DBG", std.string.toString(msg));
		}
	}
	static bit isErrored() {
		return errored;
	}

}
